/*
	CVSNT Generic API
    Copyright (C) 2004 Tony Hoyle and March-Hare Software Ltd

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef SQLRECORDSET__H
#define SQLRECORDSET__H

class CSqlField
{
public:
	CSqlField() { }
	virtual ~CSqlField() { }

	virtual operator int() =0;
	virtual operator size_t() =0;
	virtual operator const char *() =0;
	virtual operator const wchar_t *() = 0;
};

class CSqlRecordset
{
public:
	CSqlRecordset() { }
	virtual ~CSqlRecordset() { }

	virtual bool Close() =0;
	virtual bool Closed() const =0;
	virtual bool Eof() const =0;
	virtual bool Error() const =0;
	virtual bool Next() =0;
	virtual CSqlField* operator[](size_t item) const =0;
	virtual CSqlField* operator[](int item) const =0;
	virtual CSqlField* operator[](const char *item) const =0;
};

#endif
