#ifdef INC_MYSQL
/*
	CVSNT Generic API
    Copyright (C) 2004 Tony Hoyle and March-Hare Software Ltd

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* Note that actually *using* the MySql API forces this code and any 
   calling code to be under the GPL. Use alternatives where possible - eg. MSDE. */

#ifndef MYSQLCONNECTION__H
#define MYSQLCONNECTION__H

#include "../SqlConnection.h"
#include "MySqlRecordset.h"

#include <vector>

#ifndef _mysql_h
typedef void *MYSQL;
#endif

class CMySqlConnection : public CSqlConnection
{
public:
	CVSAPI_EXPORT CMySqlConnection();
	CVSAPI_EXPORT virtual ~CMySqlConnection();

	CVSAPI_EXPORT virtual bool Open(const char *host, const char *database, const char *username, const char *password);
	CVSAPI_EXPORT virtual bool Close();
	CVSAPI_EXPORT virtual CSqlRecordset& Execute(const char *string, ...);

protected:
	MYSQL *m_connect;
	std::vector<CMySqlRecordset> m_rsList;
};

#endif

#endif

