/* CVS auth library interface

    Copyright (C) 2004 Tony Hoyle and March-Hare Software Ltd

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __LIBRARY__H
#define __LIBRARY__H

#include "protocol_interface.h"

struct server_interface *get_server_interface();

void setup_server_interface(cvsroot_t *root, int io_socket, int (*_get_cached_password)(const char *key, char *buffer, int buffer_len),const char *(*_get_password)(const char *prompt),int (*_yesno_prompt)(const char *message, const char *title, int withcancel));
const struct protocol_interface *load_protocol(const char *protocol);
int unload_protocol(const struct protocol_interface *protocol);
const struct protocol_interface *find_authentication_mechanism(const char *tagline, bool& badauth,int io_socket, int (*_get_cached_password)(const char *key, char *buffer, int buffer_len),const char *(*_get_password)(const char *prompt),int (*_yesno_prompt)(const char *message, const char *title, int withcancel));
const char *enumerate_protocols(int *context);

typedef void *library_handle_t;

#ifdef USE_SHARED_LIBS
void *library_load(const char *library, const char *function, library_handle_t& handle);
bool library_unload(library_handle_t library);
#endif

int get_global_config_data(const char *key, const char *value, char *buffer, int buffer_len);
int set_global_config_data(const char *key, const char *value, const char *buffer);
int enum_global_config_data(const char *key, int value_num, char *value, int value_len, char *buffer, int buffer_len);
const char *get_config_dir();
const char *get_library_dir();
bool set_config_dir(const char *dir);
bool set_library_dir(const char *dir);
void set_encrypted_channel(int encrypt);
int get_encrypted_channel();

#ifdef _WIN32
void ReportError(BOOL bError, LPCSTR szError, ...);
#endif

#endif
